
; ========================================================
;			
;    -- VM_Grid.asm --
;			Jay Sullivan
; ========================================================
  

;------------------------------------------------
;               Header
;------------------------------------------------

	.data
	grid_ClassName db 'VMPagesGrid',0
	gridItem_ClassName db 'VMPagesItem',0
	szReserved db  'Reserved ',0
	szCommitted db 'Committed',0
	
	.data?
	grid_Wnd	  HWND ?
	gridItems	  DWORD ? ; new GridItem[dwReservedPages];
	
	

;------------------------------------------------
;	This is the entire grid window
;------------------------------------------------

.code
GridRegister PROC
LOCAL wc:WNDCLASSEX
		mov wc.cbSize, Sizeof WNDCLASSEX
		mov wc.style, CS_HREDRAW or CS_VREDRAW
		mov wc.lpfnWndProc, Offset GridWnd
		mov wc.cbClsExtra,NULL
		mov wc.cbWndExtra,4
		mov eax,hInstance
		mov wc.hInstance,eax
		mov wc.hbrBackground, COLOR_WINDOW+12
		mov wc.lpszMenuName, NULL
		mov wc.lpszClassName, Offset grid_ClassName
		invoke LoadIcon, NULL, IDI_APPLICATION 
		mov wc.hIcon,eax
		mov wc.hIconSm,0
		invoke LoadCursor, NULL,IDC_ARROW
		mov wc.hCursor,eax
		invoke RegisterClassEx, ADDR wc
	ret
GridRegister ENDP

GridItemVars STRUCT
	state  dd ?
	hWnd   dd ?
	pPage  dd ?
	index  dd ?
	
GridItemVars ENDS

GridWnd PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM


	mov eax, uMsg
	;-----------------------------
	 .if eax==WM_CREATE
	;-----------------------------
			eEXSTYLE equ WS_EX_STATICEDGE
			eSTYLE   equ WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT
			itemWIDTH equ 100
			itemHEIGHT equ 25
			
		;-----------------------------
		; new GridItem[dwReservedPages];
		;-----------------------------
			invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,(Sizeof GridItemVars)*dwReservedPages
			mov gridItems, eax
			.if eax==0
				invoke MessageBox,hwnd,$String("HeapAlloc returned zero."),$String("*HeapAlloc failed.*"),MB_OK
			.endif
			
		;-----------------------------
		; Make Grid Items
		;-----------------------------

		gSIZE equ Sizeof GridItemVars
		
		
		push esi
		mov esi, gridItems
		for i, <0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21>
			invoke CreateWindowEx, eEXSTYLE, Offset gridItem_ClassName, Offset szReserved, eSTYLE, 5,i*30+5,itemWIDTH,itemHEIGHT,hWnd,0,hInstance,0 
			mov [esi+i*gSIZE].GridItemVars.hWnd, eax
			mov [esi+i*gSIZE].GridItemVars.state, 0
			mov [esi+i*gSIZE].GridItemVars.index, i
			mov ecx, lpVirtualBase
			add ecx, i*dwPageSize
			mov [esi+i*gSIZE].GridItemVars.pPage, ecx
			lea ecx, [esi+i*gSIZE]
			invoke SetWindowLong,eax,GWL_USERDATA,ecx
		endm
		pop esi
		
	;-----------------------------
	 .elseif eax==WM_CLOSE
	;-----------------------------
		invoke ShowWindow,hWnd,SW_HIDE
		xor eax,eax
		ret
	;-----------------------------
	 .else
	;-----------------------------
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
	;-----------------------------
	.endif
	;-----------------------------
	
	xor eax,eax
	ret
GridWnd ENDP


;------------------------------------------------
;	This is a button on the window
;------------------------------------------------
GridItemRegister PROC
LOCAL wc:WNDCLASSEX
		mov wc.cbSize, Sizeof WNDCLASSEX
		mov wc.style, CS_HREDRAW or CS_VREDRAW 
		mov wc.lpfnWndProc, Offset GridItemWnd
		mov wc.cbClsExtra,NULL
		mov wc.cbWndExtra,4
		mov eax,hInstance
		mov wc.hInstance,eax
		mov wc.hbrBackground, COLOR_WINDOW+15
		mov wc.lpszMenuName, NULL
		mov wc.lpszClassName, Offset gridItem_ClassName
		invoke LoadIcon, NULL,IDI_HAND
		mov wc.hIcon,eax
		mov wc.hIconSm,0
		invoke LoadCursor, NULL,IDC_HAND
		mov wc.hCursor,eax
		invoke RegisterClassEx, ADDR wc
	ret
GridItemRegister ENDP

GridItemWnd PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL ps:PAINTSTRUCT,
	  hdc:HDC,
	  hPen:HPEN,
	  myStr:DWORD,
	  myColor:DWORD

	mov eax, uMsg
	;-----------------------------
	 .if eax==WM_PAINT
	;-----------------------------
	
	
		;-----------------------------
		; Reserved or Committed?
		;-----------------------------
		
			invoke GetWindowLong,hWnd,GWL_USERDATA 
			
		;-----------------------------
		; Reserved or Committed? Set String/Color
		;-----------------------------
		
			.if [eax].GridItemVars.state != 0
				mov myStr, Offset szCommitted
				mov myColor, 0BFDFFFh
			.else
				mov myStr, Offset szReserved
				mov myColor, 0FFDFBFh
			.endif
		;-----------------------------
		; Paint!
		;-----------------------------
		
			invoke BeginPaint,hWnd,ADDR ps
			mov hdc, eax
			invoke SetBkColor,hdc,myColor
			invoke TextOut,hdc,15,3,myStr,9
			invoke EndPaint,hWnd,ADDR ps
			
	
	;-----------------------------
	 .elseif eax==WM_MOUSEACTIVATE
	;-----------------------------
		;invoke GetWindowLong,hWnd,GWL_USERDATA 
		;mov [eax].GridItemVars.state, 0
		;invoke VirtualFree,[eax].GridItemVars.pPage,dwPageSize,MEM_DECOMMIT
	  	;invoke InvalidateRect,hWnd, 0, FALSE
	;-----------------------------
	 .else
	;-----------------------------
	
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
	;-----------------------------
	 .endif
	;-----------------------------
	
	xor eax,eax
	ret
GridItemWnd ENDP